/* vi: set tabstop=4 nocindent noautoindent: */


/**
lbg[NpCu   network.c

wb_
	#include "network.h"


*/


#include "network.h"
#include "time.h"





/**
int  udp_server_socket(int port)   

	@\: UDP̃T[o\Pbg,ڑ҂ԂɂȂD
  
		  ̊֐ŌĂяolbg[N֐
			  socket(), bind()

	: port -- |[gԍ

	߂l: 0ȏ  쐬ꂽ\PbgLqqD
			   -1  \Pbg쐬łȂD
			   -3  oChɎsD
 */
int  udp_server_socket(int port) 
{
	int  sofd, err;
	struct sockaddr_in sv_addr;
 
	sofd = (int)socket(AF_INET, SOCK_DGRAM, 0);
	if (sofd<0) return -1;
 
	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	// TIME_WAIT ȂݒD
/*	struct linger lg;
	lg.l_onoff  = 1;
	lg.l_linger = 0;
	err = setsockopt(sofd, SOL_SOCKET, SO_LINGER, &lg, sizeof(lg));
	if (err<0) {
		socket_close(sofd);
		return -2;
	} 
*/
	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -3;
	}

	return sofd;
}





/**
int  udp_server_socket_setopt(int port, int opt, const void* optval, int optlen) 

	@\: UDP̃T[o\Pbg,ڑ҂ԂɂȂD
		  setsockopt()t
  
		  ̊֐ŌĂяolbg[N֐
			  socket(), setsockopt(), bind()

	: port -- |[gԍ

	߂l: 0ȏ  쐬ꂽ\PbgLqqD
			   -1  \Pbg쐬łȂD
			   -2  \PbgIvV̐ݒɎsD
			   -3  oChɎsD
 */
int  udp_server_socket_setopt(int port, int opt, const void* optval, int optlen) 
{
	int  sofd, err;
	struct sockaddr_in sv_addr;
 
	sofd = (int)socket(AF_INET, SOCK_DGRAM, 0);
	if (sofd<0) return -1;
 
	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	if (opt>0) {
		#ifdef WIN32
			err = setsockopt(sofd, SOL_SOCKET, opt, (const char*)optval, optlen);
		#else
			err = setsockopt(sofd, SOL_SOCKET, opt, optval, optlen);
		#endif
		if (err<0) {
			socket_close(sofd);
			return -2;
		} 
	}

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -3;
	}

	return sofd;
}





/**
int  udp_client_socket(char* hostname, int port, struct sockaddr_in* sv_addr)

	@\: UDP̃NCAg\PbgD
		  Iꍇ, *sv_addrɃT[ȍ񂪊i[D

		  ̊֐ŌĂяolbg[N֐
			  socket(), gethostbyname()

	:  hostname T[o
		   port	    T[o|[gԍ
		   sv_addr	sockaddr_in\̂ւ̃|C^

	߂l: 쐬ꂽ\PbgLqqD
			G[̏ꍇ0̒l߂D
				-1  \Pbg쐬łȂD
				-2  T[o̎擾ɎsD
*/
int  udp_client_socket(char* hostname, int port, struct sockaddr_in* sv_addr)
{
	int  sofd;
	struct hostent* shost;
 
	sofd = (int)socket(AF_INET, SOCK_DGRAM, 0);
	if (sofd<0) return -1;
 
	shost = gethostbyname(hostname); 
	if (shost==NULL) {
		socket_close(sofd);
		return -2;
	}

	memset(sv_addr, 0, sizeof(*sv_addr));
	sv_addr->sin_family = AF_INET;
	sv_addr->sin_port   = htons(port);
	memcpy(&(sv_addr->sin_addr), shost->h_addr, shost->h_length);
   
	return sofd;
}





/**
int  udp_bind(int sofd, int port)  

	@\: UDP\PbgɃ|[goChD

 */
int  udp_bind(int sofd, int port) 
{
	int  err;
	struct sockaddr_in sv_addr;
 
	if (sofd<=0) return sofd;

	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -1;
	}

	return sofd;
}





/**
int  udp_bind_setopt(int sofd, int port, int opt, const void* optval, int optlen) 

	@\: UDP\PbgɃ|[goChD
		  setsockopt()t

 */
int  udp_bind_setopt(int sofd, int port, int opt, const void* optval, int optlen) 
{
	int  err;
	struct sockaddr_in sv_addr;
 
	if (sofd<=0) return sofd;

	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	if (opt>0) {
		#ifdef WIN32
			err = setsockopt(sofd, SOL_SOCKET, opt, (const char*)optval, optlen);
		#else
			err = setsockopt(sofd, SOL_SOCKET, opt, optval, optlen);
		#endif
		if (err<0) {
			socket_close(sofd);
			return -2;
		} 
	}

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -1;
	}

	return sofd;
}





/**
int  tcp_server_socket(int port)

@  @\: TCP̃T[o\PbgAbXɂڑv󂯂
		  ɂD̊֐ɑ accept()֐ĂԎɂ,ۂ̐ڑ҂
		  ԂƂȂD
  
		  ̊֐ŌĂяolbg[N֐
			  socket(), bind(), listen()

	: port  |[gԍD

	߂l: ΍쐬ꂽ\PbgLqqD
			sꍇ0̒lԂD
				-1  \Pbg̍쐬ɎsD
				-3  oChɎsD
				-4  bX̐ݒɎsD
*/
int  tcp_server_socket(int port) 
{
	int  sofd, err;
	struct sockaddr_in sv_addr;
 
	sofd = (int)socket(AF_INET, SOCK_STREAM, 0);
	if (sofd<0) return -1;
 
	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -3;
	}

	err = listen(sofd, 10);
	if (err==-1) {
		socket_close(sofd);
		return -4;
	}

	return sofd;
}





/**
int  tcp_server_socket_setopt(int port, int opt, const void* optval, int optlen) 

@  @\: TCP̃T[o\PbgAbXɂڑv󂯂ԂɂD
		  ̊֐ɑ accept()֐ĂԎɂ,ۂ̐ڑ҂ԂƂȂD
		  setsockopt()t
  
		  ̊֐ŌĂяolbg[N֐
			  socket(), setsockopt(), bind(), listen()

	: port  |[gԍD

	߂l: ΍쐬ꂽ\PbgLqqD
			sꍇ0̒lԂD
				-1  \Pbg̍쐬ɎsD
				-2  \PbgIvV̐ݒɎsD
				-3  oChɎsD
				-4  bX̐ݒɎsD
*/
int  tcp_server_socket_setopt(int port, int opt, const void* optval, int optlen) 
{
	int  sofd, err;
	struct sockaddr_in sv_addr;
 
	sofd = (int)socket(AF_INET, SOCK_STREAM, 0);
	if (sofd<0) return -1;
 
	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	if (opt>0) {
		#ifdef WIN32
			err = setsockopt(sofd, SOL_SOCKET, opt, (const char*)optval, optlen);
		#else
			err = setsockopt(sofd, SOL_SOCKET, opt, optval, optlen);
		#endif
		if (err<0) {
			socket_close(sofd);
			return -2;
		}
	}

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -3;
	}

	err = listen(sofd, 10);
	if (err==-1) {
		socket_close(sofd);
		return -4;
	}

	return sofd;
}





/**
int  tcp_server_bind(int port)

@  @\: TCP̃T[õ\PbgLqqAoChD
		  tcp_server_socket() Ƃ̈Ⴂ listen()֐ĂяoȂ_ɂD

		  ̊֐ŌĂяolbg[N֐ 
			  socket(), bind()

	: port  |[gԍD

	߂l: ΍쐬ꂽ\PbgLqqD
			sꍇ0̒lԂD
				-1  \Pbg̍쐬ɎsD
				-3  oChɎsD
 */
int  tcp_server_bind(int port) 
{
	int  sofd, err;
	struct sockaddr_in sv_addr;
 
	sofd = (int)socket(AF_INET, SOCK_STREAM, 0);
	if (sofd<0) return -1;
 
	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -3;
	}

	return sofd;
}





/**
int  tcp_server_bind_setopt(int port, int opt, const void* optval, int optlen) 

@  @\: TCP̃T[õ\PbgLqqAoChD
		  tcp_server_socket() Ƃ̈Ⴂ listen()֐ĂяoȂ_ɂD
		  setsockopt()t

		  ̊֐ŌĂяolbg[N֐ 
			  socket(), setsockopt(), bind()

	: port  |[gԍD

	߂l: ΍쐬ꂽ\PbgLqqD
			sꍇ0̒lԂD
				-1  \Pbg̍쐬ɎsD
				-2  \PbgIvV̐ݒɎsD
				-3  oChɎsD
 */
int  tcp_server_bind_setopt(int port, int opt, const void* optval, int optlen) 
{
	int  sofd, err;
	struct sockaddr_in sv_addr;
 
	sofd = (int)socket(AF_INET, SOCK_STREAM, 0);
	if (sofd<0) return -1;
 
	if (opt>0) {
		#ifdef WIN32
			err = setsockopt(sofd, SOL_SOCKET, opt, (const char*)optval, optlen);
		#else
			err = setsockopt(sofd, SOL_SOCKET, opt, optval, optlen);
		#endif
		if (err<0) {
			socket_close(sofd);
			return -2;
		}
	}

	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -3;
	}

	return sofd;
}





/**
int  tcp_client_socket(char* hostname, int port)

	@\: TCP̃NCAg\PbgAT[oɐڑD

		  ̊֐ŌĂяolbg[N֐ 
			  socket(), gethostbyname(), connect()

	: hostname   T[o
		  port	     T[o|[gԍ

	߂l: ΍쐬ꂽ\PbgLqqD
			sꍇɂ0̒l߂D
				-1  \Pbg̍쐬ɎsD
				-2  T[o̎擾ɎsD
				-3  T[oւ̐ڑɎsD
  */
int  tcp_client_socket(char* hostname, int port) 
{
	int sofd, err;
	struct hostent	 *shost;
	struct sockaddr_in sv_addr;

	sofd = (int)socket(AF_INET, SOCK_STREAM, 0);
	if (sofd<0) return -1;
 
	shost = gethostbyname(hostname); 
	if (shost==NULL) {
		socket_close(sofd);
		return -2;
	}

	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	memcpy(&sv_addr.sin_addr, shost->h_addr, shost->h_length);

	err = connect(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -3;
	}

	return sofd;
}






/**
int  tcp_client_bind_socket(char* hostname, int sport, int cport)  

	@\: TCP̃NCAg\PbgAT[oɐڑD

		  ̊֐ŌĂяolbg[N֐ 
			  socket(), bind(), gethostbyname(), connect()

	: hostname   T[o
		  sport	     T[o|[gԍ
		  cport      ̃|[gԍ

	߂l: ΍쐬ꂽ\PbgLqqD
			sꍇɂ0̒l߂D
				-1  \Pbg̍쐬ɎsD
				-2  BINDsD
				-3  T[o̎擾ɎsD
				-4  T[oւ̐ڑɎsD
  */
int  tcp_client_bind_socket(char* hostname, int sport, int cport)  
{
	int sofd, err;
	struct hostent  *shost;
	struct sockaddr_in sv_addr;

	sofd = (int)socket(AF_INET, SOCK_STREAM, 0);
	if (sofd<0) return -1;
 
	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(cport);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -2;
	}

	shost = gethostbyname(hostname); 
	if (shost==NULL) {
		socket_close(sofd);
		return -3;
	}

	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(sport);
	memcpy(&sv_addr.sin_addr, shost->h_addr, shost->h_length);

	err = connect(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -4;
	}

	return sofd;
}





/**
int  tcp_bind(int sofd, int port)  

	@\: TCP\PbgɃ|[goChD

 */
int  tcp_bind(int sofd, int port)  
{
	int  err;
	struct sockaddr_in sv_addr;
 
	if (sofd<=0) return sofd;

	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -1;
	}

	return sofd;
}





/**
int  tcp_bind_setopt(int sofd, int port, int opt, const void* optval, int optlen)  

	@\: TCP\PbgɃ|[goChD
		  setsockopt() t

 */
int  tcp_bind_setopt(int sofd, int port, int opt, const void* optval, int optlen)  
{
	int  err;
	struct sockaddr_in sv_addr;
 
	if (sofd<=0) return sofd;

	if (opt>0) {
		#ifdef WIN32
			err = setsockopt(sofd, SOL_SOCKET, opt, (const char*)optval, optlen);
		#else
			err = setsockopt(sofd, SOL_SOCKET, opt, optval, optlen);
		#endif
		if (err<0) {
			socket_close(sofd);
			return -2;
		} 
	}

	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	err = bind(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) {
		socket_close(sofd);
		return -1;
	}

	return sofd;
}





/**
int  accept_intr(int sock, struct sockaddr* cl_addr, socklen_t* cdlen)

	@\: accept()ŃubNɊ荞݂|āCaccept()sŏIĂ
          Ď{sł悤ɂ邽߂̃bp[֐ (for Solaris)

	: sock     \Pbg
		  cl_addr  \Pbg̏񂪓 sockaddr\̂ւ̃|C^
@@@@@cdlen    *cl_addr ̃TCYD

	߂l: ΍쐬ꂽ\PbgLqqD
			sꍇɂ0̒l߂D
			-1  G[D
  */
int accept_intr(int sock, struct sockaddr* cl_addr, socklen_t* cdlen)
{
	int nsofd = 0;

	do {
		nsofd = (int)accept(sock, cl_addr, cdlen);
	} while (nsofd==-1 && errno==EINTR);

	//if (nsofd<0) Error("accept_intr");

	return nsofd;
}





/*
int  tcp_connect(int sofd, char* hostname, int port)

	@\: TCP̃NCAg\PbgʂāAT[oɐڑD

		  ̊֐ŌĂяo֐
			  gethostbyname(), connect()

	: sofd	   \Pbgʎq
		  hostname   T[o
		  port	   T[o|[gԍ

	߂l:  0D
			sꍇɂ0̒l߂D
				-1  T[o̎擾ɎsD
				-2  T[oւ̐ڑɎsD
  */
int  tcp_connect(int sofd, char* hostname, int port) 
{
	int  err;
	struct hostent  *shost;
	struct sockaddr_in sv_addr;

	shost = gethostbyname(hostname); 
	if (shost==NULL) return -1;

	memset(&sv_addr, 0, sizeof(sv_addr));
	sv_addr.sin_family = AF_INET;
	sv_addr.sin_port   = htons(port);
	memcpy(&sv_addr.sin_addr, shost->h_addr, shost->h_length);

	err = connect(sofd, (struct sockaddr*)&sv_addr, sizeof(sv_addr));
	if (err<0) return -2;
	return 0;
}





/**
int  socket_close(int sofd)

	@\: M̃f[^jāA\PbgSɕD
	      fork() ꍇCevZX socket_close()ƁCqvZX̃\PbgɂeyڂD

	: sofd   N[Y\PbgLqqwD

	߂l: ɏI΍ŌɎMoCgAłȂꍇɂ-1ԂD
*/
int  socket_close(int sofd)
{
	int  err = -1;

	if (sofd>0) {
		#ifdef WIN32
			err = shutdown(sofd, 2);
			closesocket(sofd);
		#else
			err = shutdown(sofd, SHUT_RDWR);
			close(sofd);
		#endif
	}
	return err;
}







/////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//

/**
int  udp_recv(int sock, char* rmsg, int size, struct sockaddr_in* sv_addr)

	@\: recvform() bsO֐DUDPf[^MD

	: sock	 \PbgLqq
		  rmsg	 Mpf[^obt@
		  size	 f[^obt@̃TCY
		  sv_addr  T[ȍ񂪊i[ꂽ sockaddar_in \̂ւ̃|C^D
 
	߂l: Mɍs΂̃oCgD
			s-1ԂD
*/
int  udp_recv(int sock, char* rmsg, int size, struct sockaddr_in* sv_addr)
{
	int cc;
 	socklen_t cadlen;

	cadlen = sizeof(*sv_addr);
	memset(rmsg, 0, size);
	cc = recvfrom(sock, rmsg, size, 0, (struct sockaddr*)sv_addr, &cadlen);

	return cc;
}





/**
int  udp_send(int sock, char* smsg, int size, struct sockaddr_in* sv_addr)

	@\: sendto() bsO֐DUDPoRŃf[^𑗂D
		  f[^(smsg)̃TCY size0ȉw肵ꍇ́Asmsg͕
		  ƌȂăTCYIɌvZD

	: sock	 \PbgLqq
		  smsg	 Mf[^
		  size	 Mf[^ismsgj̃TCYDTCY 0ȉ̏ꍇ
				   smsg͕łƂ݂ȂD
		  sv_addr  T[ȍi[ sockaddar_in \̂ւ̃|C^D

	߂l: Mɍs΂̃oCgD
			s-1ԂD
*/
int  udp_send(int sock, char* smsg, int size, struct sockaddr_in* sv_addr)
{
	int cc;

	if (size<=0) size = (int)strlen(smsg);
//	hton_ar(smsg, size);
	cc = sendto(sock, smsg, size, 0, (struct sockaddr*)sv_addr, sizeof(*sv_addr));

	return cc;
}





/**
int  tcp_recv(int sock, char* rmsg, int size)
 
	@\: recv()bsO֐DTCPoRŃf[^MD

	: sock	 \PbgLqq
		  rmsg	 Mpf[^obt@
		  size	 f[^obt@̃TCY

	߂l: Mɍs΂̃oCgD
			s-1ԂD
			0 ̏ꍇ͐ؒfD
*/
int  tcp_recv(int sock, char* rmsg, int size)
{
	int cc;

	memset(rmsg, 0, size);
	cc = recv(sock, rmsg, size, 0);

	return cc;
}





/**
int  tcp_send(int sock, char* smsg, int size)

	@\: send()bsO֐DTCPoRŃf[^𑗂D
		  f[^(smsg)̃TCY size0ȉw肵ꍇ́Asmsg͕
		  łƌȂ,TCYIɌvZD

	: sock   \PbgLqq
		  smsg   Mf[^
		  size   Mf[^ismsgj̃TCYDTCY 0ȉ̏ꍇ
				 smsg͕łƂ݂ȂD

	߂l: ꍇ͂̑MoCgD
			sꍇɂ-1ԂD
*/
int  tcp_send(int sock, char* smsg, int size)
{
	int cc;

	if (size<=0) size = (int)strlen(smsg);
	cc = send(sock, smsg, size, 0);

	return cc;
}




/**
int  udp_recv_wait(int sock, char* rmsg, int size, struct sockaddr_in* sv_addr, int tm)

  	@\FUDPoRŃf[^MD
  		  ^CAEg̐ݒ肪\D^CAEg 0w肵ꍇ, recv_wait()
  		  ֐Ăяo_œǂݍ݉\f[^Ȃ΂Ƀ^CAEg
     	  ƂȂ (RECV_TIMEOUTED Ԃ)D

	: sock	 \PbgLqq
		  rmsg	 Mpf[^obt@
		  size	 f[^obt@̃TCY
		  sv_addr  T[ȍ񂪊i[ꂽ sockaddar_in \̂ւ̃|C^D
	  	  tm	 ^CAEgԁDbPʁD
 
	߂l: Mɍs΂̃oCgD
			s-1ԂD
	  		RECV_TIMEOUTED	  	^CAEgD
*/
int  udp_recv_wait(int sock, char* rmsg, int size, struct sockaddr_in* sv_addr, int tm)
{
	int  cc;

	if (recv_wait(sock, tm)) {
		cc = udp_recv(sock, rmsg, size, sv_addr); 
	}
	else {
		return RECV_TIMEOUTED;
	}
	return cc;
}






/**
int  udp_send_mesg(int sock, char* smsg, struct sockaddr_in* sv_addr)

	@\: UDPŕf[^𑗂D

	: sock	 \PbgLqq
		  smsg	 Mf[^
		  sv_addr  T[ȍi[ sockaddar_in \̂ւ̃|C^D

	߂l: Mɍs΂̃oCgD
			s-1ԂD

	#define  udp_send_mesg(s, m, a)     udp_send((s), (m), 0, (a))
*/






/**
int  tcp_recv_wait(int sock, char* mesg, int sz, int tm)

  	@\FTCPoRŃf[^MD
  		  ^CAEg̐ݒ肪\D^CAEg 0w肵ꍇ, recv_wait()
  		  ֐Ăяo_œǂݍ݉\f[^Ȃ΂Ƀ^CAEg
     	  ƂȂ (RECV_TIMEOUTED Ԃ)D

  	:
	  	sock	\PbgLqq
	  	mesg	Mpf[^obt@
	  	sz	 	f[^obt@̃TCY
	  	tm	 	^CAEgԁDbPʁD

  	߂l:
	  	1ȏ   MoCgD
	  	0		炭͑葤ZbVN[YD
	  	-1		MG[D
	  	RECV_TIMEOUTED	  	^CAEgD
*/
int  tcp_recv_wait(int sock, char* mesg, int sz, int tm)
{
	int  cc;

	if (recv_wait(sock, tm)) {
		cc = recv(sock, mesg, sz, 0); 
	}
	else {
		return RECV_TIMEOUTED;
	}
	return cc;
}





/**
int  tcp_send_mesg(int sock, char* mesg)

  	@\FTCPoRŃbZ[W()𑗐MD

  	F
	  	sock	 \PbgLqq
	  	mesg	 MpbZ[W

  	߂lF
	  	ꍇ͂̑MoCgD
	  	sꍇɂ-1ԂD

  	_ł͎̂̓}NłD
	  #define  tcp_send_mesg(s, m)  tcp_send((s), (m), 0)
*/







/**
int  tcp_send_mesgln(int sock, char* mesg)

	@\FTCPbZ[W()ɉs(\r\n)tđMD

	F
	  sock	 \PbgLqq
	  mesg	 MpbZ[W

  	߂lF
	  ꍇ͂̑M(܂މs)D
	  sꍇɂ-1ԂD
*/
int  tcp_send_mesgln(int sock, char* mesg)
{
	int   cc, sz;
	char* buf;

	sz = (int)strlen(mesg) + 3;	/* CR+LF+0x00 */
	buf = (char*)malloc(sz);
	if (buf==NULL) return -1;

	strncpy(buf, mesg, sz);
	strncat(buf, "\r\n", 2);
//	hton_ar(buf, strlen(buf));
	cc = send(sock, buf, (int)strlen(buf), 0);

	free(buf);
	return cc;
}






/**
int  tcp_recv_mstream(int sock, char* mesg, int sz, mstream* sb, int tm)

	@\FTCPoRŃbZ[W()MDMbZ[W̓bZ[WXg[
		@obt@ɈUobt@OC̊֐ɂsǂݏoDmesgɂ͍ő
		@sz-1i[DCobt@̈s̃f[^ sz-1傫ꍇ
@		@͂ݏô͎ĂD
		  mesgɊi[鎞Cs̉sR[h͍폜Csɂ͕K \0 D
  		  ^CAEg̐ݒ肪\Ń^CAEg 0w肵ꍇ, Ăяo_
  		  ǂݍ݉\f[^Ȃ΂Ƀ^CAEgƂȂ (RECV_TIMEOUTED Ԃ)D
		  bZ[WXg[̃obt@mۂĂȂꍇ́CŏɌĂяoꂽ_
		@mۂDŮ֐gpāCMf[^obt@OC\Pbg
		  N[Y܂ŁCǂݎɂ͕KXg[gpĂ̊֐Ăяo΂
		  ΂ȂȂDŖꍇ͎Mf[^͕̐ۏ؂ȂD

  	F
	 	sock	\PbgLqq
	  	mesg	Mpf[^obt@D\ߏ\ȃ̈mۂĂD
	  	sz	 	f[^obt@̃TCY
		sb      Xg[obt@iOobt@^̃Xg[obt@j
                obt@mۂĂȂ΁CIɊmۂD
	  	tm	 	^CAEgԁDbPʁD

	߂lF
	  	1ȏ   mesgɊi[bZ[W̃oCgD
	  	0  		炭͑葤ZbVN[YD
	  	-1  	MG[D
		-2  	 NULL̃f[^D
		-3  	bZ[Wobt@̂Ŋmۂ悤ƂCmۂɎsD
		-4  	bZ[Wobt@Ƀf[^݂͑͂Cs̗RɂlɎsD
		-5  	bZ[Wobt@̃f[^̒Cmesg̒傫D͂ݏô͎ĂꂽD
	  	RECV_TIMEOUTED  	^CAEgD
*/
int  tcp_recv_mstream(int sock, char* mesg, int sz, mstream* sb, int tm)
{
	int  cc;
	unsigned char* pp;

	if (mesg==NULL || sb==NULL) return -2;
	memset(mesg, 0, sz);

	if (sb->buf==NULL) {
		*sb = make_mstream(RECVBUFSZ);
		if (sb->buf==NULL) return -3;
	}

	while (sb->datano==0) {
		cc = tcp_recv_wait(sock, mesg, sz, tm);
		if (cc<=0) return cc;
		put_mstream(sb, (unsigned char*)mesg);
		memset(mesg, 0, sz);
	}

	pp = get_mstream(sb);
	if (pp==NULL) return -4;
	if (strlen((const char*)pp)>=(unsigned int)sz) {
		memcpy(mesg, pp, sz-1);
		free(pp);
		return -5;
	}
	memcpy(mesg, pp, strlen((const char*)pp));

	free(pp);
	return (int)strlen(mesg);
}





///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// VOi
//		tools.c ֈړD 2006 9/5

/**
void  set_sigterm_child()

	@\Fchild vZX̏IݒD

	tools.c ֈړD 2006 9/5
*/
/*
void  set_sigterm_child()
{
	struct sigaction ca;

	ca.sa_handler = sigterm_child;
	ca.sa_flags   = SA_NOCLDSTOP | SA_RESTART;
	sigemptyset(&ca.sa_mask);
	sigaction(SIGCHLD, &ca, NULL);
}
*/




/**
void  sigterm_child(int signal)

	@\Fchild vZX̏I

	tools.c ֈړD 2006 9/5
*/
/*
void  sigterm_child(int signal)
{
	pid_t pid = 0;
	int ret;

	do {
		pid = waitpid(-1, &ret, WNOHANG);
	} while(pid>0);
}
*/







///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// AhX
//

/**
char*  get_hostname_bynum(unsigned char* num) 

	@\: IPAhXi4byte 1byte unsigned jzXgtD 

	FIPAhXi4byte 1byte unsigned jD 

	߂lFzXgij
*/
char*  get_hostname_bynum(unsigned char* num) 
{
	int   len;
	char* hname;
	struct hostent* hent;

	#ifdef WIN32
		hent = gethostbyaddr((const char*)num, 4, AF_INET);
	#else
		hent = gethostbyaddr(num, 4, AF_INET);
	#endif
	
	if (hent==NULL) return NULL;

	len = (int)strlen(hent->h_name);
	hname = (char*)malloc(len+1);
	if (hname==NULL) {
		free(hent);
		return NULL;
	}
	memcpy(hname, hent->h_name, len+1);

	return hname;	
}

	



/**
char*  get_hostname(char* ipaddr) 

	@\: IPAhXijzXgtD 
		  FQDNw肵ꍇ́Cċt̂ŁCFQDÑ`FbN
		@gpłD

	FIPAhXij܂ FQDN 

	߂lFzXgij
*/
char*  get_hostname(char* ipaddr) 
{
	char*  name;
	unsigned char* num;

	num  = to_address_num4(ipaddr, 1);
	if (num==NULL) return NULL;

	name = get_hostname_bynum(num); 
	free(num);

	return name;	
}

	




#ifdef WIN32

unsigned char*  get_myipaddr_num() 
{
	unsigned char* ipnum  = NULL;
	char* ipaddr = get_localip();

	if (ipaddr!=NULL) {
		ipnum = to_address_num8(ipaddr, 0);
		free(ipaddr);
	}

	return ipnum;
}


#else

/**
char*  get_myipaddr() 

	@\: lbg[NC^[tFCXCԍŏɌ
@@@@@UPԂŃ[vobNłȂC^[tFCXIPAhX
		  lbg}XNԂDCC^[tFCX̐
 		   MAXIFNO ȓłC葽͖̂D

		  lbg}XNKvȂȂ get_localip() gpĂǂD

	: ȂD

	߂l: [IPAhX]/[lbg}XN] ̕

 */
char*  get_myipaddr() 
{
	char* addr;
	unsigned char* n;

	n = get_myipaddr_num();
	if (n==NULL) return NULL;

	addr = (char*)malloc(32);
	if (addr==NULL) {
		free(n);
		return NULL;
	}
	memset(addr, 0, 32);

	snprintf(addr, 31, "%d.%d.%d.%d/%d.%d.%d.%d", n[0], n[1], n[2], n[3], n[4], n[5], n[6], n[7]);

	free(n);
	return addr;
}






/**
unsigned char*  get_myipaddr_num() 

	@\: lbg[NC^[tFCXCԍŏɌ
@@@@@UPԂŃ[vobNłȂC^[tFCXIPAhX
		  lbg}XNԂDCC^[tFCX̐
 		   MAXIFNO ȓłCȏ͖D

		  gIPAhXm@ƂẮC gethostname() 
		  gethostbyname() g@D
			j struct hostent  *shost;
				.....................
				gethostname(hostname, sizeof(hostname));
				shost = gethostbyname(hostname);

		  ܂Cget_localip() ̕@gD

	: ȂD

	߂l: [IPAhX],[lbg}XN] ̒8byte 1byte unsigned D

 */

unsigned char*  get_myipaddr_num() 
{
	int	i, sofd, len;

	unsigned char*  addr = NULL;
	struct ifconf  ifc;
	struct ifreq*  ifq;
	struct ifreq*  ifp;


	len = sizeof(struct ifreq)*MAXIFNO;
	ifp = ifq = (struct ifreq*)malloc(len);
	if (ifq==NULL) return NULL;
	ifc.ifc_len = len;
	ifc.ifc_req = ifq;

	sofd = socket(AF_INET, SOCK_DGRAM, 0);
	if (sofd<0) {
      	perror("get_myipaddr_num: socket");
		return NULL;
	}


	// C^[tFCX̎擾
	if (ioctl(sofd, SIOCGIFCONF, &ifc)<0) {
		socket_close(sofd);
		free(ifq);
		return NULL;
	}


	ifp = ifq;
	for (i=0; i<MAXIFNO; i++) {

		// C^[tFCX̃tO擾
		if (ioctl(sofd, SIOCGIFFLAGS, ifp)<0) {
			socket_close(sofd);
			free(ifq);
			return NULL;
		}

		if ((ifp->ifr_flags&IFF_UP) && !(ifp->ifr_flags&IFF_LOOPBACK)) {
			int j;
			unsigned char* p = (unsigned char*)ifp->ifr_addr.sa_data;

			addr = (unsigned char*)malloc(8);
			if (addr==NULL) {
				socket_close(sofd);
				free(ifq);
				return NULL;
			}

			// AhX擾
			if (ioctl(sofd, SIOCGIFADDR, ifp)<0) {
				socket_close(sofd);
				free(ifq);
				free(addr);
				return NULL;
			}
			for (j=0; j<4; j++) addr[j] = p[j+2];

			// lbg}XN擾
			if (ioctl(sofd, SIOCGIFNETMASK, ifp)<0) {
				socket_close(sofd);
				free(ifq);
				free(addr);
				return NULL;
			}
			for (j=0; j<4; j++) addr[j+4] = p[j+2];

			return addr;
		}
		ifp++;
	}
	
	socket_close(sofd);
	free(ifq);
	return NULL;
}

#endif





/**
char*  get_localip()

	@\: g IPAhX𓾂̕@D
		  [g}Vɐڑi_~[j݁C̃C^[tFCX
@@@@@lD

	: ȂD

	߂l: IPAhX ̕
            gpI free() Kv

 */
// #define get_localip() get_localip_bydest("202.26.158.1")
           




/**
char*  get_localip_bydest(char* dest)

	@\: ڑw肵āC֐ڑ C^[tFCXIPAhX𓾂
		  g IPAhX𓾂̕@D

	: ڑ

	߂l: IPAhX ̕
            gpI free() Kv

 */
char*  get_localip_bydest(char* dest)
{
    int   err, sofd;
	socklen_t len;
	char* addr;
	char* ip;
	struct sockaddr_in localif;  
	struct sockaddr_in remote;             
	
	if (dest==NULL) return NULL; 	
	ip = get_ipaddr_byname(dest);
	if (ip ==NULL)  return NULL;

	memset(&localif, 0, sizeof(struct sockaddr_in));  
	memset(&remote,  0, sizeof(struct sockaddr_in));  
	remote.sin_family      = AF_INET;  
	remote.sin_addr.s_addr = inet_addr(ip);  
	remote.sin_port        = htons(9999);             
	free(ip);

	sofd = (int)socket(AF_INET, SOCK_DGRAM, 0);  
	if (sofd<0) return NULL;

  	err = connect(sofd, (struct sockaddr*)&remote, sizeof(remote));
  	if (err<0) {
      	socket_close(sofd);
     	return NULL;
    }

  	len = sizeof(localif);
  	err = getsockname(sofd, (struct sockaddr *)&localif, &len);
	if (err<0) {
      	socket_close(sofd);
      	return NULL;
    }
  	socket_close(sofd);

	addr = get_ipaddr(localif.sin_addr);
  	return addr;
}
           




/**
char*  get_ipaddr(struct in_addr sin_addr)

	@\: in_addr\̂ IPAhXlD

	: in_addr  -- sockaddr_in\̂̃o,o sin_addrłD

	߂l: IPAhX()ւ̃|C^D
            gpI free() Kv

	:
	   struct sockaddr_in addr
	   .........;
	   ipaddr = get_ipaddr(addr.sin_addr); 

*/
char*  get_ipaddr(struct in_addr sin_addr)
{
	char* ip;
	unsigned char* pp;

	pp = (unsigned char*)&(sin_addr);
	if (pp[0]==0) return NULL;

	ip = (char*)malloc(16);
	if (ip==NULL) return NULL;
	memset(ip, 0, 16);

	snprintf(ip, 15, "%d.%d.%d.%d", pp[0], pp[1], pp[2], pp[3]);

	return ip;
}




/**
unsigned char*  get_ipaddr_num(struct in_addr sin_addr)

	@\: in_addr\̂ IPAhXlD

	: in_addr  -- sockaddr_in\̂̃o,o sin_addrłD

	߂l: IPAhX(1byte unsiged z)ւ̃|C^i4bytejD
            gpI free() Kv

	:
	   struct sockaddr_in addr
	   .........;
	   ipaddr = get_ipaddr_num(addr.sin_addr); 

*/
unsigned char*  get_ipaddr_num(struct in_addr sin_addr)
{
	unsigned char* ip;
	unsigned char* pp;

	ip = (unsigned char*)malloc(4);
	if (ip==NULL) return NULL;

	pp = (unsigned char*)&(sin_addr);
	memcpy(ip, pp, 4);

	return ip;
}





/**
char*  get_ipaddr_byname(char* hostname)

	@\: zXg IPAhXlD

	: hostname -- zXg

	߂l: IPAhX()ւ̃|C^D
            gpI free() Kv

*/
char*  get_ipaddr_byname(char* hostname)
{
	struct hostent *host;
	char* ip;
	unsigned char* pp;

	host = gethostbyname(hostname); 
	if (host==NULL) return NULL;

	ip = (char*)malloc(16);
	if (ip==NULL) return NULL;
	memset(ip, 0, 16);

	pp = (unsigned char*)(host->h_addr);
	snprintf(ip, 15, "%d.%d.%d.%d", pp[0], pp[1], pp[2], pp[3]);

	return ip;
}





/**
char*  get_ipaddr_byname_num(char* hostname)

	@\: zXg IPAhXlD

	: hostname -- zXg

	߂l: IPAhX(1byte unsiged z)ւ̃|C^i4bytejD
            gpI free() Kv

*/
unsigned char*  get_ipaddr_byname_num(char* hostname)
{
	struct hostent *host;
	unsigned char* ip;
	unsigned char* pp;

	host = gethostbyname(hostname); 
	if (host==NULL) return NULL;
	ip = (unsigned char*)malloc(4);
	if (ip==NULL) return NULL;

	pp = (unsigned char*)(host->h_addr);
	memcpy(ip, pp, 4);

	return ip;
}





/**
char*  get_mynetaddr()

	@\: ̃lbg[NAhXԂ

	߂l: lbg[NAhX()ւ̃|C^D
            gpI free() Kv
*/
char*  get_mynetaddr()
{
	char* net;
	unsigned char* pp;

	pp = get_mynetaddr_num();
	if (pp==NULL) return NULL;

	net = (char*)malloc(16);
	if (net==NULL) {
		free(pp);
		return NULL;
	}
	memset(net, 0, 16);

	snprintf(net, 15, "%d.%d.%d.%d", pp[0], pp[1], pp[2], pp[3]);

	free(pp);
	return net;
}





/**
unsigned char*  get_mynetaddr_num()

	@\: ̃lbg[NAhXԂ

	߂l: lbg[NAhX(1byte unsiged z)ւ̃|C^i4bytejD
            gpI free() Kv

*/
unsigned char*  get_mynetaddr_num()
{
	int  i;
	unsigned char* net;
	unsigned char* ip;
	unsigned char* mk;
		
	ip = get_myipaddr_num();
	if (ip==NULL) return NULL;
	mk = &(ip[4]);

	net = (unsigned char*)malloc(4);
	if (net==NULL) {
		free(ip);
		return NULL;
	}

	for (i=0; i<4; i++) net[i] = ip[i] & mk[i];

	free(ip);
	return net;
}




/**


*/
struct sockaddr_in  get_sockaddr(char* hostname, unsigned short cport)
{
	struct sockaddr_in  ss_addr;
	struct hostent *shost;

	// Serveȑ ss_addrɊi[
	shost = gethostbyname(hostname);
	if (shost==NULL) {
		DEBUG_MESG("GET_HOST_INFO: Error: cannot find hostname %s\n", hostname);
		ss_addr.sin_family = 0;
		ss_addr.sin_port   = 0;
		return ss_addr;
	}

	memset(&ss_addr, 0, sizeof(ss_addr));
	ss_addr.sin_family = AF_INET;
	ss_addr.sin_port   = htons(cport);
	memcpy(&(ss_addr.sin_addr), shost->h_addr, shost->h_length);

	return ss_addr;
}




struct sockaddr_in  get_sockaddr_bynum(char* ipnum, unsigned short cport)
{
	struct sockaddr_in  ss_addr;

	memset(&ss_addr, 0, sizeof(ss_addr));
	ss_addr.sin_family = AF_INET;
	ss_addr.sin_port   = htons(cport);
	memcpy(&(ss_addr.sin_addr), ipnum, 4);

	return ss_addr;
}





struct sockaddr_in  get_local_sockaddr(unsigned short cport)
{
	struct sockaddr_in  ss_addr;
	struct hostent *shost;


	// localhost ̏ ss_addrɊi[
	shost = gethostbyname("127.0.0.1");

	memset(&ss_addr, 0, sizeof(ss_addr));
	ss_addr.sin_family = AF_INET;
	ss_addr.sin_port   = htons(cport);
	memcpy(&(ss_addr.sin_addr), shost->h_addr, shost->h_length);

	return ss_addr;
}




/**
int  is_same_sockaddr(struct sockaddr_in addr1, struct sockaddr_in addr2) 

	addr1  addr2i[ IPAhXƃ|[gԍǂ


*/
int  is_same_sockaddr(struct sockaddr_in addr1, struct sockaddr_in addr2) 
{
	int i, len;
	unsigned char *p1, *p2;

	p1  = (unsigned char*)&(addr1.sin_addr);
	p2  = (unsigned char*)&(addr2.sin_addr);
	len = sizeof(addr1.sin_addr);

	for (i=0; i<len; i++) {
		if (p1[i]!=p2[i]) return FALSE;
	}

	p1  = (unsigned char*)&(addr1.sin_port);
	p2  = (unsigned char*)&(addr2.sin_port);
	len = sizeof(addr1.sin_port);

	for (i=0; i<len; i++) {
		if (p1[i]!=p2[i]) return FALSE;
	}

	return TRUE;
}





/**
int  is_same_network_num(unsigned char* addr1, unsigned char* addr2, unsigned char* mask)

	@\F^AhX addr1  addr2lbg[NɑĂ邩ǂ`FbND

	Faddr1, addr2 -- rAhXi^j4Byte
		  mask		   -- lbg}XNi^j4Byte

	߂lFFALSE  lbg[NłȂ
		 	TRUE   lbg[NłD

*/
int  is_same_network_num(unsigned char* addr1, unsigned char* addr2, unsigned char* mask)
{
	int i;

	if (addr1==NULL || addr2==NULL) return FALSE;

	if (mask==NULL) {
		for (i=0; i<4; i++) {
			if (addr1[i] != addr2[i]) return FALSE;
		}
	}
	else {
		for (i=0; i<4; i++) {
			if ((addr1[i]&mask[i]) != (addr2[i]&mask[i])) return FALSE;
		}
	}
	return TRUE;
}






/**
int  is_same_network(char* addr1, char* addr2, char* mask)

	@\F^AhX addr1  addr2lbg[NɑĂ邩ǂ`FbND
		  addr1, addr2  FQDNłD

	Faddr1, addr2 -- rAhXi^j
		  mask		   -- lbg}XNi^j

	߂lFFALSE  lbg[NłȂ
		 	TRUE   lbg[NłD

*/
int  is_same_network(char* addr1, char* addr2, char* mask)
{
	int  ret;
	unsigned char* a1;
	unsigned char* a2;
	unsigned char* mk;

	if (addr1==NULL || addr2==NULL || mask==NULL) return FALSE;

	a1 = to_address_num4(addr1, 1);
	a2 = to_address_num4(addr2, 1);
	mk = to_address_num4(mask,  0);
	if (a1==NULL || a2==NULL || mk==NULL) {
		freeNull(a1);
		freeNull(a2);
		freeNull(mk);
		return FALSE;
	}

	ret = is_same_network_num(a1, a2, mk);
	freeNull(a1);
	freeNull(a2);
	freeNull(mk);
	
	return TRUE;
}








/**
unsigned char*  to_address_num8(char* addr, int mode)

	@\F^̃AhX [IPAhX]/[lbg}XN] (F202.26.159.140/255.255.255.0j
		  ^̃AhXiunsigned char* num[8]j8Byte ֕ϊD
		  ȗꂽꏊ 0Ƃ݂ȂiF202.26/255  202.26.0.0/255.0.0.0j
		  lbg}XNŜȗꂽꍇ IPAhXɈˑD(202.26.  202.26.0.0/255.255.0.0)
		  CIDER`ɂΉC
		  Clbg}XN̑Ó̓`FbNȂD

	Faddr -- ϊ镶^IPAhX
		  mode -- 0 : IPAhXȊỐipj NULL ԂD
				@0ȊOFFQDNIPAhXɕϊĕԂiԂj

	߂l: [IPAhX],[lbg}XN] ̒8byte 1byte unsigned D
*/
unsigned char*  to_address_num8(char* addr, int mode)
{
	unsigned char* num;
	char* ps;
	char* pc;
	char* uc = NULL;
	int   i;

	if (addr==NULL) return NULL;

	num = (unsigned char*)malloc(8);
	if (num==NULL) return NULL;
	memset(num, 0, 8);


	// IPAhX̕ϊ
 	ps = awk(addr, '/', 1);
	if (ps==NULL) {
		free(num);
		return NULL;
	}

	i = (int)strlen(ps) - 1;
	while (i>0 && ps[i]=='.') i--;
	if (i>0) {
		if (isalpha(ps[i])) {
			if (mode==0) { // mode==0Ȃ FQDN->IPAhX ͍sȂȂD
				free(num);
				free(ps);
				return NULL;
			}
			uc = (char*)get_ipaddr_byname_num(ps);
			if (uc==NULL) {
				free(num);
				free(ps);
				return NULL;
			}
		}
	}

	if (uc==NULL) { 						// IPAhX\L̏	
		for (i=0; i<4; i++) {
			pc = awk(ps, '.', i+1);
			if (pc==NULL) break;
			num[i] = (unsigned char)atoi(pc);
			free(pc);
		}
	}
	else { 									// zXg\L̏
		for (i=0; i<4; i++) num[i] = uc[i];
		free(uc);
	}
	free(ps);


 	ps = awk(addr, '/', 2);

	// Tulbg}XNȗꂽꍇ̏
	if (ps==NULL) {
		int f = OFF;
		for (i=3; i>=0; i--) {
			if (num[i]!=0 || f==ON) {
				num[i+4] = 0xff;
				f = ON;
			}
			else {
				num[i+4] = 0;
			}
		}
		return num;
	}


	// Tulbg}XN̏
	for (i=0; i<4; i++) {
		pc = awk(ps, '.', i+1);
		if (pc==NULL) break;
		num[i+4] = (unsigned char)atoi(pc);
		free(pc);
	}
	free(ps);


	// CIDER`Ή
	if (num[4]<=32 && num[5]==0 && num[6]==0 && num[7]==0) {
		int nn, cl = (int)num[4];
		for (i=0; i<4; i++) {
			nn = 8 - Max(0, Min(8, cl-8*i));
			num[i+4] = 0xff<<nn;
		}
	}

	return  num;
}







/**
char*  to_address_char8(unsigned char* num)

	@\F^ IPAhX num 8Byte𕶎^́@[IPAhX]/[lbg}XN]@ɕϊD
		  num ͕Klbg}XN̏܂݁C 8BytełȂƂȂD8Byte菭Ȃꍇ
		  炭ZOe[VG[ND
		  ӁD
		  to_address_num()Ƒ΂ŎĝSD

	F 8byte 1byte unsigned ^ [IPAhX],[lbg}XN]

	߂lF[IPAhX]/[lbg}XN] `̕
*/
char*  to_address_char8(unsigned char* n)
{
	char* addr;
	if (n==NULL) return NULL;

	addr = (char*)malloc(32);
	if (addr==NULL) return NULL;
	memset(addr, 0, 32);

	snprintf(addr, 31, "%d.%d.%d.%d/%d.%d.%d.%d", n[0], n[1], n[2], n[3], n[4], n[5], n[6], n[7]);

	return addr;
}






/**
unsigned char*  to_address_num4(char* addr, int mode)

	@\F^̃AhX [IPAhX] (F202.26.159.140j
		  ^̃AhXiunsigned char* num[4]j4Byte ֕ϊD
		  ȗꂽꏊ 0Ƃ݂ȂiF202.26  202.26.0.0j
		  v free()

	Faddr -- ϊ镶^IPAhX
		  mode -- 0 : IPAhXȊỐipj NULL ԂD
				@0ȊOFFQDNIPAhXɕϊĕԂiԂj

	߂l: [IPAhX] ̒4byte 1byte unsigned D
*/
unsigned char*  to_address_num4(char* addr, int mode)
{
	unsigned char* num;
	char* pc;
	char* uc = NULL;
	int   i;

	if (addr==NULL) return NULL;

	num = (unsigned char*)malloc(4);
	if (num==NULL) return NULL;
	memset(num, 0, 4);


	// IPAhX̕ϊ
	i = (int)strlen(addr) - 1;
	while (i>0 && addr[i]=='.') i--;
	if (i>0) {
		if (isalpha(addr[i])) {
			if (mode==0) { // mode==0Ȃ FQDN->IPAhX ͍sȂȂD
				free(num);
				return NULL;
			}
			uc = (char*)get_ipaddr_byname_num(addr);
			if (uc==NULL) {
				free(num);
				return NULL;
			}
		}
	}

	if (uc==NULL) { 						// IPAhX\L̏	
		for (i=0; i<4; i++) {
			pc = awk(addr, '.', i+1);
			if (pc==NULL) break;
			num[i] = (unsigned char)atoi(pc);
			free(pc);
		}
	}
	else { 									// zXg\L̏
		for (i=0; i<4; i++) num[i] = uc[i];
		free(uc);
	}

	return  num;
}







/**
char*  to_address_char4(unsigned char* num)

	@\F^ IPAhX num 4Byte𕶎^ [IPAhX] ɕϊD
		  num ͕Klbg}XN̏܂݁C 4BytełȂƂȂD4Byte菭Ȃꍇ
		  炭ZOe[VG[ND
		  ӁD
		  to_address_num4()Ƒ΂ŎĝSD

	F 4byte 1byte unsigned ^ [IPAhX]

	߂lF[IPAhX] `̕
*/
char*  to_address_char4(unsigned char* n)
{
	char* addr;
	if (n==NULL) return NULL;

	addr = (char*)malloc(16);
	if (addr==NULL) return NULL;
	memset(addr, 0, 16);

	snprintf(addr, 15, "%d.%d.%d.%d", n[0], n[1], n[2], n[3]);

	return addr;
}






/**
int   recv_wait(int sock, int tm)

	@\FȈ Mwait. \PbgɃf[^M܂ő҂D
		  XbhΉ

	Fsock		Ď\Pbg
		@tm		^CAEg̕b

	߂lF^		obt@Ƀf[^D
			U		^CAEgD
*/
int   recv_wait(int sock, int tm)
{
	int    nd;
	fd_set mask;
	struct timeval timeout;
	time_t otm, ntm;

	otm = time(NULL);
	do {
		timeout.tv_sec  = tm;
		timeout.tv_usec = 0;
		FD_ZERO(&mask);
		FD_SET(sock, &mask);

		//DEBUG_MESG("Waiting sock = %d for %ds.\n", sock, tm);
		nd  = select(sock+1, &mask, NULL, NULL, &timeout);
		ntm = time(NULL);
	} while ((nd<0 || !FD_ISSET(sock, &mask)) && (int)(ntm-otm)<=tm);

	return FD_ISSET(sock, &mask); 	
}




int   recv_wait_twin(int sock1, int sock2, int tm)
{
	int	   ret = 0;
	int    nm, nd;
	fd_set mask;
	struct timeval timeout;
	time_t otm, ntm;

	nm  = Max(sock1, sock2);
	otm = time(NULL);
	do {
		timeout.tv_sec  = tm;
		timeout.tv_usec = 0;
		FD_ZERO(&mask);
		FD_SET(sock1, &mask);
		FD_SET(sock2, &mask);
		nd  = select(nm+1, &mask, NULL, NULL, &timeout);
		ntm = time(NULL);
	} while ((nd<0 || (!FD_ISSET(sock1, &mask) && !FD_ISSET(sock2, &mask))) && (int)(ntm-otm)<=tm);


	if (FD_ISSET(sock1, &mask)) ret += 1;
	if (FD_ISSET(sock2, &mask)) ret += 2;

	return ret;
}




/**
int   send_wait(int sock, int tm)

	@\FȈ Mwait. f[^M\ɂȂ܂ő҂D
		  XbhΉ

	Fsock		Ď\Pbg
		@tm		^CAEg̕b

	߂lF^		obt@Ƀf[^D
			U		^CAEgD
*/
int   send_wait(int sock, int tm)
{
	int    nd;
	fd_set mask;
	struct timeval timeout;
	time_t otm, ntm;

	otm = time(NULL);
	do {
		timeout.tv_sec  = tm;
		timeout.tv_usec = 0;
		FD_ZERO(&mask);
		FD_SET(sock, &mask);

		//DEBUG_MESG("Waiting sock = %d for %ds.\n", sock, tm);
		nd  = select(sock+1, NULL, &mask, NULL, &timeout);
		ntm = time(NULL);
	} while ((nd<0 || !FD_ISSET(sock, &mask)) && (int)(ntm-otm)<=tm);

	return FD_ISSET(sock, &mask); 	
}




/**
void  udp_hole_punching(int sock, struct sockaddr_in addr, int nm)

	@\Fsock gāCaddr nmoCg NULLf[^𑗐MD

*/
void  udp_hole_punching(int sock, struct sockaddr_in addr, int nm)
{
	char data[LBUF];

	if (nm<=0) nm = 4;				// for SLVoice
	else if (nm>LBUF) nm = LBUF;

	memset(data, 0, nm);
	udp_send(sock, data, nm, &addr);

	return;
}










////////////////////////////////////////////////////////////////////////////////////////
// get_valid_..._socket
//

int  get_valid_udp_socket(int min, int max, unsigned short* port)
{
	int  i, sock, range;

	range = max - min + 1;
	*port = rand()%range + min;

	i = 1;
	sock = udp_server_socket((int)*port);
	while(sock<=0 && i<range) {
		(*port)++;
		if (*port>max) *port = ((int)*port)%max + min - 1;
		sock = udp_server_socket((int)*port);
		i++;
	}

	if (sock<=0) *port = 0;

	return sock;
}




int  get_valid_tcp_server_socket(int min, int max, unsigned short* port)
{
	int  i, sock, range;

	range = max - min + 1;
	*port = rand()%range + min;

	i = 1;
	sock = tcp_server_socket((int)*port);
	while(sock<=0 && i<range) {
		(*port)++;
		if (*port>max) *port = ((int)*port)%max + min - 1;
		sock = tcp_server_socket((int)*port);
		i++;
	}

	if (sock<=0) *port = 0;

	return sock;
}




int  get_valid_tcp_client_socket(int min, int max, char* hname, unsigned short sport, unsigned short* cport)
{
	int  i, sock, range;

	range  = max - min + 1;
	*cport = rand()%range + min;

	i = 1;
	sock = tcp_client_bind_socket(hname, (int)sport, (int)*cport);
	while(sock<0 && i<range) {
		(*cport)++;
		if (*cport>max) *cport = ((int)*cport)%max + min - 1;
		sock = tcp_client_bind_socket(hname, (int)sport, (int)*cport);
		i++;
	}

	if (sock<=0) *cport = 0;

	return sock;
}







//////////////////////////////////////////////////////////////////////////////////
//
// for WinSock
//

#ifdef WIN32
	WSADATA WsaData;
#endif


int  init_network(void)
{
	int ret = 0;

#ifdef WIN32
	ret = WSAStartup(MAKEWORD(2,0), &WsaData);
	if (ret!=0) WSACleanup();
#endif

	return  ret;
}



void  cleanup_network(void)
{
#ifdef WIN32
	WSACleanup();
#endif
}

